#
# Copyright (c) 2004 Jeff Pitman <symbiont@berlios.de>
#
# alternatives-config - utility from alternatives subsystem
# configures alternative candidates in debian/redhat format
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
# USA.
#

# Non-priority ending lines are slaves
!/.*(\t[[:digit:]]+)$/ {
    slaves[NR] = $0
}

$0 ~ namepat {
    masters[NR] = $0
}

END {
    base = gensub(/\/.*\//, "", "g", name)
    pri = 0
    i = 0
    for(mi in masters) {
        split(masters[mi], mf, "\t")
        if(mf[3] > pri) {
            pri = mf[3]
            best = mf[2]
        }
        i++
    }

    print ""
    print "There are " i " programs which provide ``" base "\"."
    print ""
    print "  Selection\tCommand"
    print "-----------------------------------------------"

    i = 1
    for(mi in masters) {
        split(masters[mi], mf, "\t")
        if(mf[2] == best) 
            bestchar = "*"
        else
            bestchar = " "
        if(mf[2] == current)
            currchar = "+"
        else
            currchar = " "
        print bestchar currchar "  " i "\t\t" mf[2]
        candidate[i] = mf[2]
        i++
    }

    print ""
    printf "%s", "Enter to keep the current selection[+], or type selection number: "

    getline <"/dev/stdin"

    if($0) {
        if(candidate[$0] == best)
            "alternatives-auto " name "; alternatives-update" | getline
        else
            "alternatives-manual " name " " candidate[$0] "; alternatives-update" | getline
    }
}
